unit SeveralFormsD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Outlook2000, Office2000, adxAddIn, SeveralFormsD7_TLB, StdVcl,
  Classes, adxolFormsManager, Unit1, Unit2, Unit3, uUtils;

type
  TCoSeveralFormsD7 = class(TadxAddin, ICoSeveralFormsD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxOlFormsManager1: TadxOlFormsManager;
    procedure adxOlFormsManager1Error(ASender: TObject;
      Args: TadxOlErrorEventArgs);
    procedure adxCOMAddInModuleError(const E: SysUtils.Exception;
      var Handled: Boolean);
  private
  protected
  public
    function VisibleActiveForm: TADXOlForm;
    function InactiveForm: TADXOlForm;
    function ControllingForm: TControllingForm;
  end;

implementation

{$R *.dfm}

{ TAddInModule }

function TAddInModule.InactiveForm: TADXOlForm;
var
  i, itemIndex: integer;
  item: TadxOlFormsCollectionItem;
begin
  result := nil;
  for itemIndex := 0 to 1 do begin
    item := adxOlFormsManager1.Items[itemIndex];
    for i := 0 to item.FormInstanceCount - 1 do begin
      if (item.FormInstances[i].Visible
          and (not item.FormInstances[i].Active)) then begin
        result := item.FormInstances[i];
        exit;
      end;
    end;
  end;
end;

function TAddInModule.VisibleActiveForm: TADXOlForm;
var
  i, itemIndex: integer;
  item: TadxOlFormsCollectionItem;
begin
  result := nil;
  for itemIndex := 0 to 1 do begin
    item := adxOlFormsManager1.Items[itemIndex];
    for i := 0 to item.FormInstanceCount - 1 do begin
      if (item.FormInstances[i].Visible
          and item.FormInstances[i].Active) then begin
        result := item.FormInstances[i];
        exit;
      end;
    end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1Error(ASender: TObject;
  Args: TadxOlErrorEventArgs);
begin
  Args.Handled := true;
  Common.ShowError(Strings.FormsManagerOnError + #13#10 + Args.E.Message);
end;

procedure TAddInModule.adxCOMAddInModuleError(const E: SysUtils.Exception;
  var Handled: Boolean);
begin
  Handled := true;
  Common.ShowError(Strings.AddinModuleOnError + #13#10 + E.Message);
end;

function TAddInModule.ControllingForm: TControllingForm;
begin
  try
    result := adxOlFormsManager1.Items[2].FormInstances[0] as TControllingForm;
  except
    result := nil;
  end;
end;

initialization
  TadxFactory.Create(ComServer, TCoSeveralFormsD7, CLASS_CoSeveralFormsD7, TAddInModule);

end.
