unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Outlook2000, adxolFormsManager, StdCtrls, ExtCtrls;

type
  TControllingForm = class(TadxOlForm)
    RadioGroup1: TRadioGroup;
    procedure adxOlFormADXBeforeFormShow(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure UpdateRadioGroup; overload;
    procedure UpdateRadioGroup(form: TADXOlForm); overload;
  published
    { Published declarations }
  end;

{NOTE: The adxOlForm3 variable is intended for the exclusive use
       by the TadxOlFormsCollectionItem Designer.
       NEVER use this variable for other purposes.}
var
  ControllingForm : TControllingForm;

implementation

uses SeveralFormsD7_IMPL, Unit1, Unit2;

{$R *.DFM}

procedure TControllingForm.adxOlFormADXBeforeFormShow(Sender: TObject);
begin
  UpdateRadioGroup;
end;

procedure TControllingForm.RadioGroup1Click(Sender: TObject);
var
  inactiveForm: TADXOlForm;
begin
  inactiveForm := (AddinModule as TAddinModule).InactiveForm();
  if (inactiveForm <> nil) then begin
    case (RadioGroup1.ItemIndex) of
      0: if (inactiveForm is TADXOlForm1) then begin
           inactiveForm.Activate();
         end;
      1: if (inactiveForm is TADXOlForm2) then begin
           inactiveForm.Activate();
         end;
    end;
  end;
end;

procedure TControllingForm.UpdateRadioGroup;
var
  form: TADXOlForm;
begin
  form := (self.AddinModule as TAddInModule).VisibleActiveForm();
  self.UpdateRadioGroup(form);
end;

procedure TControllingForm.UpdateRadioGroup(form: TADXOlForm);
begin
  if (form <> nil) then begin
    if (form is TADXOlForm1) then begin
      RadioGroup1.ItemIndex := 0;
    end;
    if (form is TADXOlForm2) then begin
      RadioGroup1.ItemIndex := 1;
    end;
  end;
end;

initialization
  RegisterClass(TPersistentClass(TControllingForm));

finalization
end.
